﻿function clientStorage() { }

if (typeof localStorage !== "undefined") {
    clientStorage.hasValue = function () { return localStorage.length > 0; }
    clientStorage.setValue = function(key, value) { return localStorage.setItem(key, value); }
    clientStorage.getValue = function (key) { return localStorage.getItem(key); }
    clientStorage.clear = function() { localStorage.clear(); }
}
else if (typeof document.cookie !== "undefined") {
    clientStorage.hasValue = function () { return document.cookie.length > 0; }
    clientStorage.setValue = function (key, value) { return clientStorage.setCookieValue(key, value); }
    clientStorage.getValue = function (key) { return clientStorage.getCookieValue(key); }
    clientStorage.clear = function () { clientStorage.clearCookies(); }
}

clientStorage.clearCookies = function () {
    var kvps = document.cookie.split(";");
    for (var i = 0; i < kvps.length; i++) {
        var storageKey = kvps[i].substr(0, kvps[i].indexOf("=")).trim();
        if (storageKey.length > 0) {
            clientStorage.setValue(storageKey, "", -1);
        }
    }
}

clientStorage.setCookieValue = function(key, value, daysToExpire) {
    if (typeof daysToExpire === "undefined") { daysToExpire = 365; }
    var expireDate = new Date();
    expireDate.setDate(expireDate.getDate() + daysToExpire);
    document.cookie =
        key.trim() + "=" + escape(value) + "; expires=" + (expireDate.toUTCString()) + "; path=/";
}

clientStorage.getCookieValue = function(key) {
    var kvps = document.cookie.split(";");
    for (var i = 0; i < kvps.length; i++) {
        var storageKey = kvps[i].substr(0, kvps[i].indexOf("=")).trim();
        if (storageKey === key) {
            var storageValue = kvps[i].substr(kvps[i].indexOf("=") + 1);
            return unescape(storageValue);
        }
    }
}

