﻿function defaultAjax() {
}

defaultAjax.PopulateProtocolTypes = function() {
    var controls = $('#ProtocolTypes');
    defaultUI.showHideLoadingIndicator(controls, true);
    $.getJSON(
        "Default.aspx?mode=ProtocolTypes",
        function(data) {
            defaultUI.populateDropDownWithOptionsAndAttributes(controls, data);
            defaultAjax.PopulateProtocolSchemaVersions();
        });
};

defaultAjax.PopulateProtocolSchemaVersions = function () {
    var controls = $('#ProtocolSchemaVersions');
    defaultUI.showHideLoadingIndicator(controls, true);
    $.getJSON(
        "Default.aspx?mode=ProtocolSchemaVersions&protocolType=" + $('#ProtocolTypes').val(),
        function (data) {
            defaultUI.populateDropDownWithOptionsAndAttributes(controls, data);
        })
        .error(function () { defaultUI.populateDropDownWithOptionsAndAttributes(controls, [{ text: "Error retreiving values"}]); });
};

defaultAjax.PopulateMessageTypes = function () {
    var controls = $('#MessageTypes');
    defaultUI.showHideLoadingIndicator(controls, true);
    $.getJSON(
        "Default.aspx?mode=MessageTypes",
        function (data) {
            defaultUI.populateDropDownWithOptionsAndAttributes(controls, data);
            defaultAjax.PopulateFinalMessageSchemas();
        })
        .error(function () { defaultUI.populateDropDownWithOptionsAndAttributes(controls, [{ text: "Error retreiving values"}]); });
};

defaultAjax.PopulateFinalMessageSchemas = function () {
    var controls = $('#FinalMessageSchemas');
    defaultUI.showHideLoadingIndicator(controls, true);
    $.getJSON(
        "Default.aspx?mode=FinalMessageSchemas&messageTypeName=" + $('#MessageTypes').val(),
        function (data) {
            defaultUI.populateDropDownWithOptionsAndAttributes(controls, data);
        })
        .error(function () { defaultUI.populateDropDownWithOptionsAndAttributes(controls, [{ text: "Error retreiving values"}]); });
};

defaultAjax.PopulatePrePopulationMethods = function () {
    var controls = $('#PrePopulationMethods');
    defaultUI.showHideLoadingIndicator(controls, true);
    $.getJSON(
        "Default.aspx?mode=PrePopulationMethods",
        function (data) {
            defaultUI.populateDropDownWithOptionsAndAttributes(controls, data);
            defaultUI.showHidePrePopulationMethods();
        })
        .error(function () { defaultUI.populateDropDownWithOptionsAndAttributes(controls, [{ text: "Error retreiving values"}]); });
};

defaultAjax.validateProtocol = function (protocolFilename, protocolType, protocolTypeSchema, messageTypeName, finalMessageSchema, callBack) {
    var validationResult = new GenerateValidationResult(protocolFilename);
    $.ajax({
        url: "Default.aspx?mode=ValidateProtocol",
        type: "POST",
        data: {
            protocolXml: encodeURIComponent(clientFsa.ReadAllFile(protocolFilename)),
            protocolType: protocolType,
            protocolTypeSchema: protocolTypeSchema,
            messageTypeName: messageTypeName,
            finalMessageSchema: finalMessageSchema
        },
        dataType: "xml",    //return data type
        success: function (response) { validationResult.setXml(response); },
        error: function (jqXHR, textStatus, errorThrown) { validationResult.setFailError("Failed to validate: " + jqXHR.responseText + ", " + textStatus); },
        complete: function () { if (typeof callBack !== "undefined") { callBack(); } }
    });
};

