<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:cd="http://www.show.scot.nhs.uk/isd/ClinicalDialogue" xmlns:gen="http://www.show.scot.nhs.uk/isd/General" xmlns:msxsl="urn:schemas-microsoft-com:xslt" xmlns:user="http://www.sci.scot.nhs.uk">
	<xsl:output method="text" encoding="utf-8" indent="no"/>
	<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
	<msxsl:script language="JScript" implements-prefix="user"><![CDATA[

	function get_month(p_Month)
   {
       var strMonth;

       switch (p_Month) {
       case "01" :
           strMonth = "Jan";
           break;
       case "02" :
           strMonth = "Feb";
           break;
       case "03" :
           strMonth = "Mar";
           break;
       case "04" :
           strMonth = "Apr";
           break;
       case "05" :
          strMonth = "May";
          break;
      case "06" :
          strMonth = "Jun";
          break;
      case "07" :
          strMonth = "Jul";
          break;
      case "08" :
          strMonth = "Aug";
          break;
      case "09" :
          strMonth = "Sep";
          break;
      case "10" :
          strMonth = "Oct";
          break;
      case "11" :
          strMonth = "Nov";
          break;
      case "12" :
          strMonth = "Dec";
          break; 
      default :
          strMonth = "   ";
   } 

  return(strMonth);

}
		function isDate(value)
   {
       return(!isNaN(new Date(value)));  
   }
    
    function UnambiguousDate(p_date)
   {
   
     var dteDate;
     var strDay, strMonth, strYear, strDate;

     // Garaunteed formats
     strDate = new String(p_date);
     strYear = strDate.substring(0,4);  
     strMonth = strDate.substring(5,7);
     strDay = strDate.substring(8,10);
  
     if (isDate(new Date(strYear,strMonth,strDay)))
     {
         return(strDay + "-" + get_month(strMonth) + "-" + strYear);
     }
}

	

   
                
    ]]></msxsl:script>
	<!-- ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ -->
	<xsl:template match="/cd:ClinicalDialogueDocument">
		<xsl:apply-templates select="./cd:MessageData/cd:PatientDemographics/gen:PatientName/gen:StructuredName"/>,
		<xsl:choose>
			<xsl:when test="/cd:ClinicalDialogueDocument/cd:MessageData/cd:PatientDemographics/gen:PatientId[gen:IdScheme='CHI']/gen:IdValue">
				<xsl:apply-templates select="/cd:ClinicalDialogueDocument/cd:MessageData/cd:PatientDemographics/gen:PatientId[gen:IdScheme='CHI']/gen:IdValue"/>
			</xsl:when>
			<xsl:when test="/cd:ClinicalDialogueDocument/cd:MessageData/cd:PatientDemographics/gen:PatientId[gen:IdScheme='NHS Number']/gen:IdValue">
				<xsl:apply-templates select="/cd:ClinicalDialogueDocument/cd:MessageData/cd:PatientDemographics/gen:PatientId[gen:IdScheme='NHS Number']/gen:IdValue"/>
			</xsl:when>
		</xsl:choose>,
		<xsl:apply-templates select="/cd:ClinicalDialogueDocument/cd:DocumentData/gen:DocumentAttestationDate"/>,
<!--		<xsl:apply-templates select="/cd:ClinicalDialogueDocument/cd:MessageData/cd:ConversationData/cd:CurrentDialogue/gen:HcpSpecialty/gen:SpecialtyName"/> -->
	</xsl:template>
	<!--
    Template will output "Patient: Unknown" if no FamilyName specified; otherwise "FamilyName" if no
    GivenName is specified; or "FamilyName, GivenName" if GivenName is specified
    -->
	<xsl:template match="gen:StructuredName">
		<xsl:choose>
			<xsl:when test="string-length(gen:FamilyName) > 0">
				<xsl:value-of select="gen:FamilyName"/>
				<xsl:if test="string-length(gen:GivenName) > 0">, <xsl:value-of select="gen:GivenName"/>
				</xsl:if>
			</xsl:when>
			<xsl:otherwise>
                Patient: Unknown
            </xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
    Template will output "CHI: {IdValue}" if a CHI is specified; otherwise "CHI: Unknown"
    -->
	<xsl:template match="gen:IdValue">
		<xsl:choose>
			<xsl:when test="string-length(.) > 0">
                CHI: <xsl:value-of select="."/>
			</xsl:when>
			<xsl:otherwise>
                CHI: Unknown
            </xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
    Template will output "NHS #: {IdValue}" if an NHS Number is specified; otherwise "NHS #: Unknown"
    -->
	<xsl:template match="gen:IdValue">
		<xsl:choose>
			<xsl:when test="string-length(.) > 0">
				NHS #: <xsl:value-of select="."/>
			</xsl:when>
			<xsl:otherwise>
				NHS #: Unknown
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<!--
    Template will output "AttestationDate" if it is specified; otherwise "Date: Unknown"
    -->
	<xsl:template match="gen:DocumentAttestationDate">
		<xsl:choose>
			<xsl:when test="string-length(.) > 0">
				<xsl:value-of select="user:UnambiguousDate(string(.))"/>
			</xsl:when>
			<xsl:otherwise>
                Date: Unknown
            </xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
    Template will output "SpecialtyName" if one is specified; otherwise "Speciality: Unknown"
    -->
	<xsl:template match="gen:SpecialtyName">
		<xsl:choose>
			<xsl:when test="string-length(.) > 0">
				<xsl:value-of select="."/>
			</xsl:when>
			<xsl:otherwise>
                Speciality: Unknown
            </xsl:otherwise>
		</xsl:choose>
	</xsl:template>
</xsl:stylesheet>
