// ============================================================================================
// File name:       calendar.js
// Created:         
// Author:          
// Description:     This file contains calendar functions.
// Dependencies:
// Issues:
// ============================================================================================

    var gdCtrl      = new Object();
    var gcBorder    = "#E6E6FF";
    var gcGray      = "#808080";
    var gcToggle    = "#E6E6FF";
    var gcBG        = "white";   

    var gdCurDate   = new Date();
    var giCurYear   = gdCurDate.getFullYear();
    var giCurMonth  = gdCurDate.getMonth()+1;
    var giCurDay    = gdCurDate.getDate();
    var giSetYear;
    var giSetMonth;
    var VicPopCal   = new Object();
    var gMonths     = new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec");

    //****************************************************************************
    // Param: popCtrl is the widget beyond which you want this calendar to appear;
    //        dateCtrl is the widget into which you want to put the selected date;
    //        popCal is the widget to display the calendar;  
    // i.e.: <input type="text" name="dc" style="text-align:center" readonly><INPUT type="button" value="V" onclick="fPopCalendar(dc,dc,popCal);return false">
    //****************************************************************************
    

    
    function closeCal(){
    
        var lngCursorX;
        var lngCursorY;
        var statusString;
        
        lngCursorX = window.event.clientX;
        lngCursorY = window.event.clientY;
        
        
            
        if ((VicPopCal.offsetLeft > lngCursorX) || (lngCursorX > (VicPopCal.offsetLeft + VicPopCal.offsetWidth)) ||  ((VicPopCal.offsetTop > lngCursorY) || (lngCursorY > (VicPopCal.offsetTop + VicPopCal.offsetHeight))))
        {
            VicPopCal.releaseCapture();
            VicPopCal.style.visibility = 'hidden';
        }
        else
        {
            if (window.event.srcElement.id=="calcontainer")
            {
                //we need to ensure the calendar has capture (or else clicking the container will cause
                //the calendar to fail to hide again when clicking out)
                VicPopCal.setCapture(false);
            
            }
        }
    
    }

    function getDayMonthYear(strDateEntered){
        var arrDate
        var lngCount
                
        arrDate = strDateEntered.split("-");
        for(lngCount=0;lngCount<=11;lngCount++){
            if(arrDate[1] == gMonths[lngCount]){
                arrDate[1] = lngCount+1;
                break;
            }
        }
        return arrDate;
    }
    
    // ========================================================================================
    function fPopCalendar(popCtrl, dateCtrl, popCal){
    // Description:  
    // Pass:         
    // Return:       
    // Raise Errors: 
    // -----------------------------------------------------
    // Date          Developer                  Comments
    // ??-???-????   ????                       Created
    // 06-May-2004   M. Meere /                 Updated the calendar functionality to set the
    //               S. Craig (RTEL)            displayed date according to the current value
    //                                          in the dateCtrl (refer to Defect # 52004 for
    //                                          further details).
    // ========================================================================================
      
var arrDateEntered;
      var strDateEntered;
      
      VicPopCal = popCal;

      gdCtrl = dateCtrl;
      strDateEntered = "";
      
      //implement code to set the calendar control to pick up the date entered
      switch(dateCtrl.tagName){
        case "SPAN"     :   {strDateEntered = dateCtrl.innerText;break;}
        case "INPUT"    :   {strDateEntered = dateCtrl.value;break;}
      }

      // Validate the date and in so doing convert it to the default form.
      // N.B. If the date isn't valid, the calendar will default to
      // displaying the current month, which is really the best result we
      // can hope for in this instance.
      strDateEntered = validateDateText(strDateEntered);

      // The default displayed date is today's.  This date is shown when the
      // date control does not contain a valid date.
      giSetYear  = giCurYear;
      giSetMonth = giCurMonth;

      // If the entered date is not null, i.e. a date was actually entered and 
      // it was found to be valid, then set the current month/year according to
      // the supplied value.      
      if(strDateEntered != ""){
        arrDateEntered = getDayMonthYear(strDateEntered);
        if(arrDateEntered.length == "3"){
            giSetYear  = arrDateEntered[2];
            giSetMonth = arrDateEntered[1];
        }
      }
      fSetYearMon(giSetYear, giSetMonth); 
        
      // Find out how close the mouse is to the corner of the window
      var rightedge  = document.body.clientWidth  - event.clientX;
      var bottomedge = document.body.clientHeight - event.clientY;
      with (VicPopCal.style) {
        // If the horizontal distance isn't enough to accomodate the width of the context menu
        if (rightedge < document.all("popTable").offsetWidth)
            // Move the horizontal position of the menu to the left by it's width
            left = document.body.offsetLeft + event.clientX - document.all("popTable").offsetWidth;
        else
            // position the horizontal position of the menu where the mouse was clicked
            left = document.body.offsetLeft + event.clientX;
        
        // Same concept with the vertical position
        if (bottomedge < document.all("popTable").offsetHeight)
            top = document.body.scrollTop + event.clientY - document.all("popTable").offsetHeight;
        else
            top = document.body.scrollTop + event.clientY;
      }
      VicPopCal.style.visibility = 'visible';    

      event.cancelBubble=true;
      //Set focus to the month drop down. This, together with an onblur=closeCal(); on the calcontainer and 
      //removing the onClick=closeCal(); on the DIV in the HTML page, seems to fix the problem where clicking
      //a year or month outwith the bounds of the calendar control closes it or clicking within the calcontainer
      //stopped hiding the calendar when clicking outwith the bounds of the calendar
      parent.document.all("tbSelMonth").focus();
	  
      // in order to make compatible with IE4.x , here I cut two line below off.
      VicPopCal.width=document.all("popTable").offsetWidth;
      VicPopCal.height=document.all("popTable").offsetHeight;
      // if u only target on IE5.x, uncommented them and delete the width&height prop in <IFrame> tag
      // thus you will find the 3rd para in fDrawCal() now works perfectly.
      
    }

    function fSetDate(iYear, iMonth, iDay){
      // Here, you could modify the locale as you need !!!!
      var outDate = iDay+"-"+gMonths[iMonth-1]+"-"+iYear;
      switch (gdCtrl.tagName) {
          case "SPAN": gdCtrl.innerText = outDate; break;
          default : gdCtrl.value = outDate; break;
      }
      VicPopCal.style.visibility = "hidden";
      VicPopCal.releaseCapture();
    }

    function fSetSelected(aCell){
      var iOffset = 0;
      var iYear = parseInt(tbSelYear.value);
      var iMonth = parseInt(tbSelMonth.value);

      aCell.bgColor = gcBG;
      with (aCell){
        var iDay = parseInt(innerText);
        if (style.color==gcGray)
            iOffset = (aCell.name<10)?-1:1;
        iMonth += iOffset;
        if (iMonth<1) {
            iYear--;
            iMonth = 12;
        }else if (iMonth>12){
            iYear++;
            iMonth = 1;
        }
      }
      fSetDate(iYear, iMonth, iDay);
    }

    function Point(iX, iY){
        this.x = iX;
        this.y = iY;
    }

    function fBuildCal(iYear, iMonth) {
      var aMonth=new Array();
      for(i=1;i<7;i++)
        aMonth[i]=new Array(i);

      var dCalDate=new Date(iYear, iMonth-1, 1);
      var iDayOfFirst=dCalDate.getDay();
      var iDaysInMonth=new Date(iYear, iMonth, 0).getDate();
      var iOffsetLast=new Date(iYear, iMonth-1, 0).getDate()-iDayOfFirst+1;
      var iDate = 1;
      var iNext = 1;

      for (d = 0; d < 7; d++)
        aMonth[1][d] = (d<iDayOfFirst)?-(iOffsetLast+d):iDate++;
      for (w = 2; w < 7; w++)
        for (d = 0; d < 7; d++)
            aMonth[w][d] = (iDate<=iDaysInMonth)?iDate++:-(iNext++);
      return aMonth;
    }

    function fDrawCal(iYear, iMonth, iCellWidth, iDateTextSize) {
        var WeekDay = new Array("Su","Mo","Tu","We","Th","Fr","Sa");
        var styleTD = " bgcolor='"+gcBG+"' width='"+iCellWidth+"' bordercolor='"+gcBG+"' valign='middle' align='center'  style='font:bold "+iDateTextSize+" Courier;";
        var strHTML;
      
        strHTML = "";
        strHTML += "<tr>";
        for(i=0; i<7; i++)
            strHTML += "<td "+styleTD+"color:#000066' >" + WeekDay[i] + "</td>";
        strHTML += "</tr>";     
        for (w = 1; w < 7; w++) {
            strHTML += "<tr>";
            for (d = 0; d < 7; d++) {
                strHTML += "<td id=calCell "+styleTD+"cursor:hand;' onMouseOver='this.bgColor=gcToggle' onMouseOut='this.bgColor=gcBG' onclick='fSetSelected(this)'>";
                strHTML += "</td>";
            }
            strHTML += "</tr>";
        }
        return(strHTML);
    }

    function fUpdateCal(iYear, iMonth) {
      myMonth = fBuildCal(iYear, iMonth);
      var i = 0;
      for (w = 0; w < 6; w++)
        for (d = 0; d < 7; d++)
            with (calCell[(7*w)+d]) {
                if (myMonth[w+1][d]<0) {
                    style.color = gcGray;
                    innerText = -myMonth[w+1][d];
                    calCell[(7*w)+d].name = i++;
                }else{
                    style.color = ((d==0)||(d==6))?"red":"black";
                    innerText = myMonth[w+1][d];
                    calCell[(7*w)+d].name = i++;
                }
            }
    }
    
    
    function fSetYearMon(iYear, iMon){
      tbSelMonth.options[iMon-1].selected = true;
      for (i = 0; i < tbSelYear.length; i++)
        if (tbSelYear.options[i].value == iYear)
            tbSelYear.options[i].selected = true;
      fUpdateCal(iYear, iMon);
    }

    function fPrevMonth(){
      var iMon = tbSelMonth.value;
      var iYear = tbSelYear.value;

      if (--iMon<1) {
          iMon = 12;
          iYear--;
      }

      fSetYearMon(iYear, iMon);
      
    }

    function fNextMonth(){
      var iMon = tbSelMonth.value;
      var iYear = tbSelYear.value;

      if (++iMon>12) {
          iMon = 1;
          iYear++;
      }

      fSetYearMon(iYear, iMon);
      
    }

    function fGetXY(aTag){
      var oTmp = aTag;
      var pt = new Point(0,0);
      do {
        pt.x += oTmp.offsetLeft;
        pt.y += oTmp.offsetTop;
        oTmp = oTmp.offsetParent;
      } while(oTmp.tagName!="BODY");
      return pt;
    }


    function makeCalendar(){        
        var strCalHTML;

        strCalHTML = '';
        strCalHTML += "<table id='popTable' border='0' bgcolor='" + gcBorder + "' >"; 
        strCalHTML += "<TR>";
        strCalHTML += "<td  id='calcontainer' valign='middle' align='center' onblur=closeCal(); ><input type='button' name='PrevMonth' value='<' style='height:20;width:20;FONT:16 Fixedsys' onClick='fPrevMonth()'>";
        strCalHTML += "&nbsp;<select id='tbSelMonth' name='tbSelMonth' onmouseover=this.setActive(); onblur=closeCal(); onchange='fUpdateCal(tbSelYear.value, tbSelMonth.value)'>";        
        for (i=0; i<12; i++)
            strCalHTML += "<option value='"+(i+1)+"'>"+gMonths[i]+"</option>";
            
        strCalHTML += "</SELECT>";
        
        strCalHTML += "&nbsp;<SELECT id='tbSelYear' name='tbSelYear' onmouseover=this.setActive(); onblur=closeCal(); onChange='fUpdateCal(tbSelYear.value, tbSelMonth.value)'>";
        for(i=1850;i<2020;i++)
            strCalHTML += "<OPTION value='"+i+"'>"+i+"</OPTION>";
        strCalHTML += "</SELECT>";
        strCalHTML += "&nbsp;<input type='button' name='PrevMonth' value='>' style='height:20;width:20;FONT:16 Fixedsys' onclick='fNextMonth()'>";
        strCalHTML += "</td>";
        strCalHTML += "</TR><TR>";
        strCalHTML += "<td align='center'>";
        strCalHTML += "<DIV style='background-color:#000066;'><table width='100%' border='0' cellpadding='2'>";
        strCalHTML += fDrawCal(giSetYear, giSetMonth, 19, 12);
        strCalHTML += "</table></DIV>";
        strCalHTML += "</td>";
        strCalHTML += "</TR><TR><TD align='center' style='cursor:hand;font:12 Fixedsys'";
        strCalHTML += " onclick='fSetDate(giCurYear,giCurMonth,giCurDay)' onMouseOver='this.style.color=gcGray' onMouseOut='this.style.color=0'>Today:&nbsp;&nbsp;"+gMonths[giCurMonth-1]+"&nbsp;"+giCurDay+",&nbsp;"+giCurYear;
        strCalHTML += "</TD></TR>";
        strCalHTML += "</TD></TR>";
        strCalHTML += "</TABLE>";
       
        
        return(strCalHTML);
    }
    
    function writeCalendar(){
        var objCal;
        var strCalHTML;
        strCalHTML = makeCalendar();
        
        if(strCalHTML != ''){
            objCal = document.all("popCal");
            if(objCal != null){
                with(objCal){
                    innerHTML = strCalHTML;
                }
            }
        }   
    }   
    
    function startCalendar(){
        if(document.readyState == 'complete')
        {   
            writeCalendar();
        }
    }
    
    document.onreadystatechange=startCalendar;
    
    
