Dim objXML

Function lowerCaseQuestionIDs(objXML)
	Dim strQuestionPath
	Dim objQuestionNodes
	Dim objQuestionNode
	Dim strID
	
	strQuestionPath = "//question"
	    
	Set objQuestionNodes = objXML.selectNodes(strQuestionPath)
	    
	'go through the questions of a protocol
	For Each objQuestionNode In objQuestionNodes
	    'get id of each question
	    strID = LCase(objQuestionNode.getAttribute("id") & "")
	    
	    Call objQuestionNode.setAttribute("id", strID)
	Next
End Function

Function getProtocolXML(objDoc)	
	Dim strXML
	'load the xml if it hasnt been loaded yet
	If(IsEmpty(objXML)) Then
		'get the xml from the opener window
		strXML = objDoc.all("protocolXML").xml
		If(strXML <> "") Then
			Set objXML = CreateObject("MSXML2.DOMDocument")
			Call objXML.loadXML(strXML)
			Call lowerCaseQuestionIDs(objXML)
		End If
	End If
End Function		

Function goToObject(strQuestionID, strRowIndex, strColIndex)
	Dim strXML
	Dim objNode
	Dim objDoc 
	Dim objProtocolWindow
    Dim strXPath
	
	Set objProtocolWindow = window.top
	Set objDoc = objProtocolWindow.document
	call getProtocolXML(objDoc)	

	'if the xml has been loaded
	If Not(IsEmpty(objXML)) Then
	
		'get the question node - this section is for the following reason:
		' When checking first client side validation, the question id's may be case sensitive.
		' However, the getProtocolXML() above converts the protocol XML id's to lower case.
		' This is because when the protocol data has been passed to the server it is converted to lower case (for reasons unknown)
		' We therfore need to check first for the case sensitive element id (for client side validation errors)
		' Then, if it's not found, check for the id as a lower case (server side validation errors)
        If (strRowIndex <> vbNullString And strColIndex <> vbNullString) Then
            strXPath = "//question[@id='" & strQuestionID & "']/column[@id='" & strColIndex & "']"
        Else
            strXPath = "//question[@id='" & strQuestionID & "']"
        End If

		Set objNode = objXML.selectSingleNode(strXPath)
		If objNode Is Nothing Then
		    Set objNode = objXML.selectSingleNode(LCase(strXPath))
		End If
		'----get the qustion node ends
		
		If Not objNode Is Nothing Then
			'go the tab index			
			Call GoToTab(getTabIndex(objNode), window.parent)
			
			If strRowIndex <> "" And strColIndex <> "" Then
				strObject = strQuestionID & "___" & strColIndex & "_" & strRowIndex
			Else
				strObject = strQuestionID
			End If
			
			strType = LCase(objNode.getAttribute("type"))
            If strType = vbNullString Then
                strType = "text"
            End If

			Select Case strType
				Case "text", "textarea", "select", "date"
					objDoc.all(strObject).focus
				Case "check"
				    objDoc.all(strObject).hidefocus = FALSE
				    objDoc.all(strObject).focus
				Case "radio"
					objDoc.all(strObject).item(0).focus
                Case "dynatable", "table", "gidynatable"
                    MsgBox "Logic flaw, we should have received a column type"
                    
			End Select
		End If
	End If
End Function

'===========================================================================
Function getTabIndex(objNode)
' Description:	Retrieves the protocol form tab index of a given protocol question node 
'               
' Pass:				Protocol question node 
' Return:			Protocol form tab index
' Raise Errors:	None
'---------------------------------------------------------------------------------------------------------------------------------------
' Date				Developer			Comments
' 19-Dec-2003	Vincent Curran    
'---------------------------------------------------------------------------------------------------------------------------------------

	'Retrieves the protocol form tab index of a given protocol question node
	Dim objRootNode
	Dim objTabNode
	Dim objChild
		
	Const PROTOCOL = "gwinternalprotocol"

	'Set Tab index to default
	getTabIndex = 1

	'Loop up the tree untill we find the protocol element
		
	Set objRootNode = objNode

	While LCase(objRootNode.NodeName) <> PROTOCOL
		On Error Resume Next
		Set objTabNode = objRootNode
		Set objRootNode = objRootNode.parentNode
		If IsEmpty(objRootNode.xml) Then
			'There is a problem with the protocol XML 
			Exit Function
		End If
	Wend
	On Error Goto 0

	For Each objChild In objRootNode.childNodes
		'IXMLDOMComment types are also included in the child list
		'But we are only interested in IXMLDOMElement types
		If LCase(TypeName(objChild)) = "ixmldomelement" Then
			If objChild.getAttribute("text") = objTabNode.getAttribute("text") Then
				Exit For
			End If
			GetTabIndex = GetTabIndex + 1
		End If
	Next
		
	Set objRootNode = Nothing
	Set objTabNode = Nothing
	Set objChild = Nothing
	'Set objNode = Nothing
		
End Function	
	
'============================================================================================
Sub GoToTab(intTabIndex, objWindow)
' Description:  Performs visual effects when selecting a referral form tab.
' Pass:         intTabIndex  - the number of the tab selected
'---------------------------------------------
' Date           Developer            Comments
' 12-Jun-2002    D. Allen-Williams    Created
'---------------------------------------------
	
    Dim strTab          'As String
    Dim strAnc          'As String
    Dim strCurrentTab   'As String
    Dim strNewTab       'As String
    Dim strSelected     'As String
    Dim intPrevTab      'As Integer
    Dim intPos          'As Integer

'---------------------------------------------
	    
    strNewTab = "divTabControl_" & intTabIndex
    strCurrentTab = objWindow.document.all("TabIndexStore").value
	    
    'Change appearance of previous tab
    intPos = instr(strCurrentTab, "_")
    intPrevTab = right(strCurrentTab, len(strCurrentTab) - intPos)
	    
    If CStr(intPrevTab) <> CStr(intTabIndex) Then
        'Change appearance of selected tab
        strSelected = "tab_" & CStr(intTabIndex) 
        objWindow.document.all(strSelected).style.backgroundColor = "#000066"
        objWindow.document.all(strSelected).style.color = "white"
	    
        'Change appearance of old tab
        strSelected = "tab_" & CStr(intPrevTab) 
        objWindow.document.all(strSelected).style.backgroundColor = "white"
        objWindow.document.all(strSelected).style.color = "black"
	        
        objWindow.document.all(strCurrentTab).style.visibility = "hidden"
        objWindow.document.all(strCurrentTab).style.display = "none"
        objWindow.document.all(strNewTab).style.display = "block"
        objWindow.document.all(strNewTab).style.visibility = "visible"
        objWindow.document.all("TabIndexStore").value = "divTabControl_" & intTabIndex
    End If
End Sub	

Sub disableUserButtons(blnDisable)
	Dim objButton
	Dim objDoc
	
	Set objDoc = window.parent.document
	
	If Not objDoc.all("trButtons").childNodes Is Nothing Then
		For Each objButton in objDoc.all("trButtons").childNodes
			objButton.disabled = blnDisable
		Next
	End If
End Sub

Function getParentLabelForQuestion(strQuestionID)
	Dim strParentLabel
	Dim objQuestionNode
	Dim objParentNode
	
	strParentLabel = ""
	
	If Not IsEmpty(objXML) Then
		Set objQuestionNode = objXML.selectSingleNode("//question[@id='" & strQuestionID & "']")							
		
		If Not objQuestionNode Is Nothing Then
			Set objParentNode = objQuestionNode.parentNode
			
			If Not objParentNode Is Nothing Then
				strParentLabel = objParentNode.getAttribute("text") & ""				
			End If
		End If
	End If
	
	getParentLabelForQuestion = strParentLabel
End Function

Function initialiseValidationBar()
	Dim objErrorXML
	Dim objErrorList
	Dim objError
	Dim objDoc
	Dim objParentDoc
	Dim objTable
	Dim objRow
	Dim objCell
	Dim objAnchor
	Dim strErrorXML
	Dim strInnerText
	Dim strQuestionID
	Dim strRowIndex
	Dim strColumnId
	Dim divErrorLinks
	Dim strParentLabel
	Dim strHTML
	Dim blnLowRes
	
	If document.readyState = "complete" Then
		Set objParentDoc = window.parent.document
		call getProtocolXML(objParentDoc)	

		blnLowRes = objParentDoc.all("isLowRes").value
		objParentDoc.all("frameValidation").scrolling = "yes"
		objParentDoc.all("frameValidation").style.display = "block"
		objParentDoc.all("errorTableHeader").innerHTML = "<P align=center><STRONG>The following fields are missing or incorrect:</STRONG></P>"
		objParentDoc.all("protocolPage").style.height = objParentDoc.all("resetHeight").value
		objParentDoc.all("iframeLoadMsg").innerHTML = ""
		document.all("divValMsg").innerHTML = ""
		If Not blnLowRes Then
			call window.parent.resizeBy(0,150)
		End If
		call disableUserButtons(False)
		
		'write the errors out dynamically using the divErrorXML 
		strErrorXML = document.all("divErrorXML").innerHTML

		Set objDoc = window.document

		strHTML = objDoc.documentElement.outerHTML

		If Len(Trim(strErrorXML)) > 0 Then
			
			Set objTable = objDoc.createElement("table")
			Set divErrorLinks = objDoc.all("divErrors")
			objTable.border	= "1"
			objTable.width	= "100%"				
			call divErrorLinks.appendChild(objTable)
			
			call createErrorHtml(objDoc, objTable, strErrorXML)
			
			strHTML = Replace(strHTML, "[ERRORTABLE]", objTable.outerHTML)
			document.write(strHTML)

		End If
	End If
End Function

Sub showClientErrors()

    document.all("protocolPage").style.height = document.all("resetHeight").value

    call ResizeWindow(document.body.offsetWidth+8,600)
       
    If Not blnIsLowRes Then
        Call ResizeWindowBy(0, 150)
    End If
    document.all("clientValidationPage").style.overflow = "auto"

    document.all("errorTableHeader").innerHTML = "<P align=center><B>The following fields are missing or incorrect:</B></P>"

	Set objTable = document.createElement("table")
	objTable.border	= "1"
	objTable.width	= "100%"

    call getProtocolXML(document)
    errorXml = document.all("schemaValidationErrors").innerHTML
    call createErrorHtml(document, objTable, errorXml)
    document.all("clientValidationPage").innerHTML = objTable.outerHTML

End Sub

Sub createErrorHtml(objDoc, objTable, errorXml)

	Set objErrorXML = CreateObject("MSXML2.DOMDocument")
	Call objErrorXML.loadXML(errorXML)
		
	If Not objErrorXML Is Nothing Then
		Set objErrorList = objErrorXML.selectNodes("//ERROR")

		For Each objError In objErrorList
			'lookup the parent label for each of the questions
			'arrAttrValues = retrieveAttrFromErrObj(objError)
								
			'create the row for the error
			Set objRow = objDoc.createElement("tr")
			call objTable.appendChild(objRow)
			
			'add the column for the link
			Set objCell = objDoc.createElement("td")
			call objRow.appendChild(objCell)
			
			Set objAnchor = objDoc.createElement("a")
			call objCell.appendChild(objAnchor)
			
			'questionId~questionText~columnId~columnText~rowIndex~message
			strQuestionID	=	objError.getAttribute("questionId") & ""
			
			'If there is a row index we are dealing with a table/dynatable
			If Len(objError.getAttribute("rowIndex") & "") = 0 Then
				strRowIndex		=	""
				strColumnId		=	""
									
				strParentLabel = getParentLabelForQuestion(strQuestionID)						
				strInnerText	=	strParentLabel & ": " & objError.getAttribute("questionText") & ""						
			Else
				strRowIndex		=	objError.getAttribute("rowIndex") & ""
				strColumnId		=	objError.getAttribute("columnId") & ""
				strInnerText	=	""
				strInnerText	=	strInnerText & "Column <b>" & objError.getAttribute("columnText") & ""
				strInnerText	=	strInnerText & "</b> in row <b>" & objError.getAttribute("rowIndex") & ""
				strInnerText	=	strInnerText & " </b>of table <b>" & objError.getAttribute("questionText") & "</b>"
			End If
			objAnchor.onclick		=	"vbscript: call goToObject('" & strQuestionID & "','" & strRowIndex & "','" & strColumnId & "')"
			objAnchor.className		=	"errorLink"
			objAnchor.innerHTML		=	strInnerText

			'add the error message
			Set objCell = objDoc.createElement("td")
			call objRow.appendChild(objCell)
			objCell.innerText = objError.getAttribute("message") & ""
			objCell.className = "errorValue"
		Next
	End If

End Sub

Function writeErrorToMsgWindow()
	Dim strHTML
	
	strHTML		=	""
	strHTML		=	strHTML & "<br><h2>" & LOCALISED_APP_NAME & " Error</h2>" & vbCrLf
	strHTML		=	strHTML & "<table border='0'>" & vbCrLf
	strHTML		=	strHTML & "<tr><td>"
	strHTML		=	strHTML & "<table border='0'>" & vbCrLf
	strHTML		=	strHTML & "<tr><td>" & divErrorMsg.innerHTML & "</td></tr>" & vbCrLf
	strHTML		=	strHTML & "<tr><td>&nbsp;</td></tr>" & vbCrLf
	strHTML		=	strHTML & "</table>"	
	strHTML		=	strHTML & "</td></tr>"
	strHTML		=	strHTML & "<tr><td align='center'>"
	strHTML		=	strHTML & "<table border='0'>" & vbCrLf	
	strHTML		=	strHTML & "<tr>" 
	strHTML		=	strHTML & "<td><input type='button' value='Close' onclick='window.close()'></td>"
	strHTML		=	strHTML & "</tr>" & vbCrLf
	strHTML		=	strHTML & "</table>"
	strHTML		=	strHTML & "</td></tr>"
	strHTML		=	strHTML & "</table>"
	
	call document.parentWindow.parent.resizeTo(786,540)
	document.parentWindow.parent.document.body.innerHTML = strHTML
End Function